C*********************************************************************
 
C...UPEVNT
C...Dummy routine, to be replaced by a user implementing external
C...processes. Depending on cross section model chosen, it either has
C...to generate a process of the type IDPRUP requested, or pick a type
C...itself and generate this event. The event is to be stored in the
C...HEPEUP commonblock, including (often) an event weight.

C...New example: handles a standard Les Houches Events File.

      SUBROUTINE UPEVNT
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
 
C...PYTHIA commonblock: only used to provide read unit MSTP(162).
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      SAVE /PYPARS/
 
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/

      logical debug
      data debug /.false./

c      integer Np,Id
c      real*8 Wgt,Scale,Aqed,Aqcd
c      integer Ipdg(MAXNUP),Istat(MAXNUP),Imoth(2,MAXNUP),Icol(2,MAXNUP)
c      real*8  Pmom(5,MAXNUP),Tau(MAXNUP),Spin(MAXNUP)

c      external getevntinfo

c      call GetEvntInfo(Np,Id,Wgt,Scale,Aqed,Aqcd,Ipdg,Istat,
c     +     Imoth,Icol,Pmom,Tau,Spin)

*.....Now fill the common block      
c      NUP = Np
c      IDPRUP = Id
c      XWGTUP = Wgt
c      SCALUP = Scale
c      AQEDUP = Aqed
c      AQCDUP = Aqcd
c*     Loop over all particles
c      do i=1,Np
c         IDUP(i) = Ipdg(i)
c         ISTUP(i) = Istat(i)
c         MOTHUP(1,i)= Imoth(1,i)
c         MOTHUP(2,i)= Imoth(2,i)
c         ICOLUP(1,i)= Icol(1,i)
c         ICOLUP(2,i)= Icol(2,i)
c         do j=1,5
c            PUP(j,i)   = Pmom(j,i)
c         enddo
c         VTIMUP(i) = Tau(i)
c         SPINUP(i) = Spin(i)
c      enddo

c.....Flush the output buffer so that C and fortran output is synchronous
      call flush(6)

      if (debug) write(6,*) 'UPEVNT called: NUP=',NUP
      call flush(6)             !flush the write buffer
      if (debug) write(6,*) '          i   id  st  M1  M2      Px
     +  Py           Pz             E            Mass'
      do i=1,NUP
         if (debug) then
            write(6,12) 'UPEVNT: ',i,IDUP(i),ISTUP(i),MOTHUP(1,i),
     +      MOTHUP(2,i),PUP(1,i),PUP(2,i),PUP(3,i),PUP(4,i),PUP(5,i),
     +      ICOLUP(1,i),ICOLUP(2,i),SPINUP(i),VTIMUP(i)
         endif
         call flush(6)   !flush the write buffer
      enddo

 12   format(a,i4,i5,i3,2i4,4e13.5,f13.5,2i4,2f10.4) 

      RETURN
      END
